\chapter{Graphs}  \label{chap-graphs}
In this Chapter we will learn how to exploit some of the 
functionalities that ROOT provides to display 
data based on the class \verb|TGraphErrors|, which you already got
to know previously. 

%
\section{Read Graph Points from File}

The fastest way in which you can fill a graph with experimental data
is to use the constructor which reads data points and their
errors from a file in ASCII (i.\,e. standard text) format:
\begin{lstlisting}
TGraphErrors(const char *filename, const char *format="%lg %lg %lg %lg", Option_t *option="");
\end{lstlisting}
The format string can be:
\begin{itemize}
 \item \verb#"\%lg \%lg"#         read only 2 first columns into X,Y
 \item \verb#"\%lg \%lg \%lg"#     read only 3 first columns into X,Y and EY
 \item \verb#"\%lg \%lg \%lg \%lg"# read only 4 first columns into X,Y,EX,EY
\end{itemize}

This approach has a the nice feature of allowing the user to reuse the 
macro for many different data sets.
Here is an example of an input file. The nice graphic result shown 
%in figure~\ref{macro2_plot} 
is produced by the macro below, which reads two such input files and uses
different options to display the data points.\\ 
%
\begin{tabular}{lr}
 \begin{minipage}{0.45\textwidth}
 \lstinputlisting{macros/macro2_input.txt}  
 \vspace{-.55pc} \hfill\small file:~\texttt{macro2\_input.txt}\\~\\
 \end{minipage}
    & 
\begin{minipage}{0.6\textwidth}
%\begin{figure}[h]
  \begin{center}
  \includegraphics[width=0.99\linewidth]{figures/graph_with_expectation}
%  \caption{  \label{macro2_plot}
%    Measured points compared with the expected values and uncertainties.}
  \end{center}
%\end{figure} 
\end{minipage} \\
\end{tabular}

\lstinputlisting{macros/macro2.cxx}  
\vspace{-.5pc} \hfill\small file: \texttt{macro2.cxx}\\~\\
%
Beyond looking at the plot, you can check the actual contents of 
the graph with the \verb|TGraph::Print()| method at 
any time, obtaining a printout of the coordinates of data 
points on screen. The macro also shows us how to print a 
coloured band around a graph instead of error bars, quite 
useful for example to represent the errors of a 
theoretical prediction.

\section{Polar Graphs}
With ROOT you can profit from rather advanced plotting routines, like the 
ones implemented in the \verb|TPolarGraph|, a class to draw graphs in polar 
coordinates. It is very easy to use, as you see in the example macro and the 
resulting plot~\ref{macro3_plot}:
% 
\lstinputlisting{macros/macro3.cxx}  
\vspace{-.5pc} \hfill\small file: \texttt{macro3.cxx}\\~\\
% 
\begin{figure}[h]
  \begin{center}
  \includegraphics[width=0.5\textwidth]{figures/polar_graph}
  \caption{  \label{macro3_plot}
   The graph of a fan obtained with ROOT.}
  \end{center}
\end{figure}
A new element was added on line 4, the size of the canvas: it is sometimes 
optically better to show plots in specific canvas sizes.

Some \python variants of this macro are shown and discussed 
in Chapter~\ref{chap-pyroot}.

%
% \section{More on Axes}
%
\section{2D Graphs}
On some occasions it might be useful to plot some quantities versus two 
variables, therefore creating a bi-dimensional graph. Of course ROOT can 
help you in this task, with the \verb|TGraph2DErrors| class.
The following macro produces a bi-dimensional graph representing a 
hypothetical measurement, fits a bi-dimensional function to it and 
draws it together with its 
x and y projections. Some points of the code will be explained in detail.
This time, the graph is populated with data points using random numbers,
introducing a new and very important ingredient, the ROOT \verb|TRandom3| 
random number generator using the Mersenne Twister 
algorithm~\cite{MersenneTwister}.
% 
\lstinputlisting{macros/macro4.cxx}  
\vspace{-.5pc} \hfill\small file: \texttt{macro4.cxx}\\~\\
% 
\begin{itemize}
 \item Line $3$: This sets the palette colour code to a much nicer one than 
the default. Comment this line to give it a try.
%
\item Line $4$: sets a style type without fill color  and shadows for pads.  
Looks much nicer on paper than the default setting.
%
\item Line $9$: The instance of the random generator. You can then draw out of 
this instance random numbers distributed according to different probability 
density functions, like the Uniform one at lines 25,26. 
See the on-line documentation to appreciate the full power of this ROOT 
feature.
%
 \item Line $10$: You are already familiar with the \verb|TF1| class. This is 
its two-dimensional correspondent. At line 21 two random numbers distributed 
according to the \verb|TF2| formula are drawn with the method \\
\verb|TF2::GetRandom2(double& a, double&b)|.
%
\item Line 26--28: Fitting a 2-dimensional function just works like in the
 one-dimensional case, i.e. initialisation of parameters and calling of the
 \verb#Fit()# method.
%
\item Line $31$: The \textit{Surf1} option draws the \verb|TF2| objects (but 
also bi-dimensional histograms) as coloured surfaces with a wire-frame on 
three-dimensional canvases.
%
 \item Line $34$--$39$: Here you learn how to create a canvas, partition it in 
two sub-pads and access them. It is very handy to show multiple plots in 
the same window or image.
\end{itemize}
